unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    Info, unit_archive;

procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
    Archiever: TArchieverDll;
    Msg: string;
begin
    if (OpenDialog1.Execute()) then
    begin
        if (RadioButton1.Checked) then
        begin
            Archiever := TArchieverDll7zip32.Create();
        end
        else if (RadioButton2.Checked) then
        begin
            Archiever := TArchieverDllCab32.Create();
        end
        else
        begin
            Archiever := TArchieverDllUnlha32.Create();
        end;
        Archiever.Extract(OpenDialog1.FileName, ExtractFilePath(OpenDialog1.FileName), Msg);
        Memo1.Lines.Add(Msg);
        Archiever.Free;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
    Archiever: TArchieverDll;
    Msg, Ext: string;
begin
    if (OpenDialog2.Execute()) then
    begin
        if (RadioButton1.Checked) then
        begin
            Archiever := TArchieverDll7zip32.Create();
            Ext := '.zip';
        end
        else if (RadioButton2.Checked) then
        begin
            Archiever := TArchieverDllCab32.Create();
            Ext := '.cab';
        end
        else
        begin
            Archiever := TArchieverDllUnlha32.Create();
            Ext := '.lzh';
        end;

        if (SaveDialog1.Execute()) then
        begin
            Archiever.Compress(OpenDialog2.Files, ChangeFileExt(SaveDialog1.FileName, Ext), Msg);
            Memo1.Lines.Add(Msg);
        end;

        Archiever.Free;
    end;
end;

end.
